/*----------------------------------------------------------------
 *	H_roma2han.c
 *
 *		Created by EunJa Kim. (POSTECH KLE Lab.)
 *		1994.
 *
-----------------------------------------------------------------*/

extern void hinput_Com2KS();

#include <stdio.h>
#include "H_index.h"
#include "H_define.h"
#include "H_roma2han.h"

int hinput_InitAutomata () {

	hinput_Cho = hinput_ChoFill;
	hinput_Jung = hinput_JungFill;
	hinput_Jong = hinput_JongFill;
	hinput_state = qS;

	return (TRUE);
}


/*----------------------------------------------------------------*/
int hinput_Minus_a(ch)
char ch;
{
	if ((ch >= 'a') && (ch <= 'z'))
		return(ch-'a');
	else if ((ch >= 'A') && (ch <= 'Z'))
		return(ch-'A');
	else
		return(-1);
}
/*----------------------------------------------------------------*/
char hinput_Comp_Mo(mo1, mo2)		/*	Moeum Combination Procedure	*/
char *mo1, mo2;
{
	switch (*mo1) {
		case 13:				/*	O	*/
			switch (mo2) {
				case 10:		/*	k	*/
					*mo1 = 14;
					break;
				case 11:		/*	l	*/
					*mo1 = 18;
					break;
				case 14:		/*	o	*/
					*mo1 = 15;
					break;
				default:
					return (0);
			}
			break;
		case 27:				/*	Eu	*/
			if (mo2 == 11)		/*	l	*/
				*mo1 = 28;
			else
				return (0);
			break;
		case 20:				/*	U	*/
			switch (mo2) {
				case 9:			/*	j	*/
					*mo1 = 21;
					break;
				case 11:		/*	l	*/
					*mo1 = 23;
					break;
				case 15:		/*	p	*/
					*mo1 = 22;
					break;
				default:
					return (0);
			}
			break;
		default:
			return(0);
			break;
	}
	return (1);
}
/*----------------------------------------------------------------*/
int hinput_Comp_Ja(ja1, ja2)			/*	Jongsung Combination Procedure
*/
char *ja1, ja2;
{
	switch (*ja1) {
		case 9:					/*	Rieul	*/
			switch (ja2) {
				case 17:		/*	r	*/
					*ja1 = 10;
					break;
				case 0:			/*	a	*/
					*ja1 = 11;
					break;
				case 16:		/*	q	*/
					*ja1 = 12;
					break;
				case 19:		/*	t	*/
					*ja1 = 13;
					break;
				case 23:		/*	x	*/
					*ja1 = 14;
					break;
				case 21:		/*	v	*/
					*ja1 = 15;
					break;
				case 6:			/*	g	*/
					*ja1 = 16;
					break;
				default:
					return (0);
			}
			break;
		case 19:				/*	Bieup	*/
			if (ja2 == 19)		/*	t	*/
				*ja1 = 20;
			else
				return (0);
			break;
		case 2:					/*	Giyeuk	*/
			if (ja2 == 19)		/*	t	*/
				*ja1 = 4;
			else
				return (0);
			break;
		case 5:					/*	Nieun	*/
			switch (ja2) {
				case 22:		/*	w	*/
					*ja1 = 6;
					break;
				case 6:			/*	g	*/
					*ja1 = 7;
					break;
				default:
					return (0);
			}
			break;
		default:
			return(0);
	}
	return (1);
}
/*----------------------------------------------------------------*/
char hinput_GenJung(ch)
char ch;
{
	if ((ch >= 'A') && (ch <= 'Z'))
		if (hinput_IsJa[hinput_Minus_a(ch)] & 0x01)
			return(hinput_Caps[hinput_Minus_a(ch)]);
	return(hinput_IJung[hinput_Minus_a(ch)]);
}
/*---------------------------------------------------------------*/
char hinput_GenJong(ch)
char ch;
{
	if ((ch >= 'A') && (ch <= 'Z')) {
		if (hinput_IsJa[hinput_Minus_a(ch)] & 0x02)
			return(hinput_Caps[hinput_Minus_a(ch)+1]);
		else
			return (0);
	} else
		return(hinput_IJong[hinput_Minus_a(ch)]);
}
/*------------------------------------------------------------*/
char hinput_GenCho(ch)
char ch;
{
	if ((ch >= 'A') && (ch <= 'Z'))
		if (hinput_IsJa[hinput_Minus_a(ch)] & 0x01)
			return(hinput_Caps[hinput_Minus_a(ch)]);
	return(hinput_ICho[hinput_Minus_a(ch)]);
}
/*------------------------------------------------------------*/
void hinput_Make2Byte(char *byte)
{
	byte[1] = 0;
	byte[0] = 0xff;
	byte[0] &= 0x80;

	byte[0] |= (hinput_Cho << 2);

	byte[0] |= (hinput_Jung >> 3);
	byte[1] |= (hinput_Jung << 5);

	byte[1] |= hinput_Jong;
	byte[2] = '\0';
}
/*----------------------------------------------------------------*/
char hinput_do_start(char ch, char *output)
{
	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) {				/* ja */
		hinput_Cho = hinput_GenCho(ch);
		hinput_Jung = hinput_JungFill;
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		return(q0);
	} else
		hinput_Cho = hinput_ChoFill;
		hinput_Jung = hinput_GenJung (ch);
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		return(q5);
}
/*----------------------------------------------------------------*/
char hinput_do_state0(char ch, char *output)
{
	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) { /* ignore previous Jaeum */
		hinput_Jung =hinput_JungFill;
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		hinput_Cho = hinput_GenCho(ch);
		hinput_Make2Byte ( &(output[2]) );
		return(q0);
	} else {		/*	ja-mo */
		hinput_Jung = hinput_GenJung(ch);
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		return(q1);
	}
}
/*----------------------------------------------------------------*/
char hinput_do_state1(char ch, char *output)
{
	char buf[16];

	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) {		/* ja-mo-ja */
		hinput_Jong = hinput_GenJong(ch);
		hinput_Make2Byte (output);
		strcpy (buf, output);
		hinput_Com2KS (buf);
		if (buf[0] != 'x') {
			hinput_N_Cho = hinput_GenCho(ch);
			return(q2);
		} else {
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte (output);
			hinput_Cho = hinput_GenCho(ch);
			hinput_Jung = hinput_JungFill;
			hinput_Make2Byte ( &(output[2]) );
			return (q0);
		}
	} else {							/* ja-mo-mo */
		hinput_Jong = hinput_JongFill;
		if (hinput_Comp_Mo(&hinput_Jung, hinput_Minus_a(ch))) {
			hinput_Make2Byte (output);
			return(q3);
		} else {
			hinput_Make2Byte (output);
			hinput_Cho = hinput_ChoFill;
			hinput_Make2Byte ( &(output[2]) );
			return (q5);
		}
	}
}
/*----------------------------------------------------------------*/
char hinput_do_state2(char ch, char *output)
{
	char buf[16];

	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) { 	/*	ja-mo-ja-ja	*/
		hinput_Jong_tmp = hinput_Jong;
		if (hinput_Comp_Ja(&hinput_Jong, hinput_Minus_a(ch))) {
			hinput_Make2Byte (output);
			strcpy (buf, output);
			hinput_Com2KS (buf);
			if (buf[0] != 'x') {
				hinput_N_Cho = hinput_GenCho(ch);
				return(q4);
			} else {
				hinput_Jong = hinput_Jong_tmp;
				hinput_Make2Byte (output);
				hinput_Cho = hinput_GenCho (ch);
				hinput_Jung = hinput_JungFill;
				hinput_Jong = hinput_JongFill;
				hinput_Make2Byte ( &(output[2]) );
				return (q0);
			}
		} else {
			hinput_Make2Byte(output);
			hinput_Cho = hinput_GenCho(ch);
			hinput_Jung = hinput_JungFill;
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte ( &(output[2]) );
			return(q0);
		}
	} else {							/* ja-mo-ja-mo */
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		hinput_Cho = hinput_N_Cho;
		hinput_Jung = hinput_GenJung(ch);
		hinput_Make2Byte( &(output[2]) );
		return(q1);
	}
}
/*----------------------------------------------------------------*/
char hinput_do_state3(char ch, char *output)
{
	char buf[16];

	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) {		/* ja-mo-mo-ja */
		hinput_Jong = hinput_GenJong(ch);
		hinput_Make2Byte (output);
		strcpy (buf, output);
		hinput_Com2KS (buf);
		if (buf[0] != 'x') {
			hinput_N_Cho = hinput_GenCho(ch);
			return(q2);
		} else {
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte (output);
			hinput_Cho = hinput_GenCho (ch);
			hinput_Jung = hinput_JungFill;
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte ( &(output[2]) );
			return (q0);
		}
	} else {							/* ja-mo-mo-mo */
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		hinput_Cho = hinput_ChoFill;
		hinput_Jung = hinput_GenJung (ch);
		hinput_Make2Byte (output);
		return(qS);
	}
}
/*----------------------------------------------------------------*/
char hinput_do_state4(char ch, char *output)
{
	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) {		/* ja-mo-ja-ja-ja */
		hinput_Make2Byte (output);
		hinput_Cho = hinput_GenCho(ch);
		hinput_Jung = 2;
		hinput_Jong = 1;
		hinput_Make2Byte ( &(output[2]) );
		return(q0);
	} else {							/* ja-mo-ja-ja-mo */
		hinput_Jong = hinput_Jong_tmp;
		hinput_Make2Byte (output);
		hinput_Cho = hinput_N_Cho;
		hinput_Jung = hinput_GenJung(ch);
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte( &(output[2]) );
		return(q1);
	}
}
/*----------------------------------------------------------------*/
char hinput_do_state5(char ch, char *output)
{
	if (hinput_IsJa[hinput_Minus_a(ch)] & 0x80) {		/* ja-mo-ja-ja-ja-ja */
		hinput_Cho = hinput_ChoFill;
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte (output);
		hinput_Cho = hinput_GenCho(ch);
		hinput_Jung = hinput_JungFill;
		hinput_Jong = hinput_JongFill;
		hinput_Make2Byte ( &(output[2]) );
		return(q0);
	} else {							/* ja-mo-ja-ja-ja-mo */
		hinput_Cho = hinput_ChoFill;
		if (hinput_Comp_Mo(&hinput_Jung, hinput_Minus_a(ch))) {
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte (output);
			return (q5);
		} else {
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte (output);
			hinput_Jung = hinput_GenJung (ch);
			hinput_Jong = hinput_JongFill;
			hinput_Make2Byte ( &(output[2]) );
			return (q5);
		}
	}
}
/*----------------------------------------------------------------*/
void hinput_DoAutomata(char ch, char *state, char *output)
{
	switch(*state) {
		case qS:	/*	Ja --> 0, Mo --> 5	*/
			*state = hinput_do_start(ch,output);
			break;
		case q0: 	/*	Ja --> 0, Mo --> 1	*/
			*state = hinput_do_state0(ch,output);
			break;
		case q1: 	/*	Ja --> 2(0), Mo --> 3(5)	*/
			*state = hinput_do_state1(ch,output);
			break;
		case q2: 	/*	Ja --> 4(0), Mo --> 1	*/
			*state = hinput_do_state2(ch,output);
			break;
		case q3: 	/*	Ja --> 2(0), Mo --> S	*/
			*state = hinput_do_state3(ch,output);
			break;
		case q4: 	/*	Ja --> 0, Mo --> 1	*/
			*state = hinput_do_state4(ch,output);
			break;
		case q5: 	/*	Ja --> 0, Mo --> S(5)	*/
			*state = hinput_do_state5(ch,output);
			break;
	}
}
/*----------------------------------------------------------------*/
char *hinput_Roma2han (char ch, char *output)
{
	hinput_DoAutomata (ch, &hinput_state, output);
	hinput_Com2KS ( output );
}
